module dshow;
import std.string, std.stdio;

enum string uuids_text = import("uuids.txt");

void printRecord(R)(R r) 
{
    foreach(fld; __traits(allMembers, R))
        writeln(fld, ": ", __traits(getMember, r, fld));
}

alias uint DWORD;
alias ushort WORD;

struct RECT {
	int left;
	int top;
	int right;
	int bottom;

	void print()
	{
		writefln("{left: %d, top: %d, right: %d, bottom: %d}", left, top, right, bottom);
	}
}

struct BITMAPINFOHEADER {
	DWORD biSize;
	int  biWidth;
	int  biHeight;
	WORD  biPlanes;
	WORD  biBitCount;
	DWORD biCompression;
	DWORD biSizeImage;
	int  biXPelsPerMeter;
	int  biYPelsPerMeter;
	DWORD biClrUsed;
	DWORD biClrImportant;
}

mixin template print_vih() {
	void print()
	{
		write("rcSource: "); rcSource.print();
		write("rcTarget: "); rcTarget.print();
		writeln("bitrate: ", dwBitRate, " AvgTimePerFrame: ", AvgTimePerFrame);
		printRecord(bmiHeader);
	}
}

struct VIDEOINFOHEADER {
    RECT            rcSource;          // The bit we really want to use
    RECT            rcTarget;          // Where the video should go
    DWORD           dwBitRate;         // Approximate bit data rate
    DWORD           dwBitErrorRate;    // Bit error rate for this stream
    ulong			AvgTimePerFrame;   // Average time per frame (100ns units)
    BITMAPINFOHEADER bmiHeader;

	mixin print_vih;
} ;

struct VIDEOINFOHEADER2 {
    RECT                rcSource;
    RECT                rcTarget;
    DWORD               dwBitRate;
    DWORD               dwBitErrorRate;
    ulong			    AvgTimePerFrame;
    DWORD               dwInterlaceFlags;
    DWORD               dwCopyProtectFlags;
    DWORD               dwPictAspectRatioX; 
    DWORD               dwPictAspectRatioY; 
    union {
        DWORD           dwControlFlags;
        DWORD           dwReserved1;
    };
    DWORD               dwReserved2;
    BITMAPINFOHEADER    bmiHeader;

	mixin print_vih;
}

align(2) struct WAVEFORMATEX { 
	WORD  wFormatTag; 
	WORD  nChannels; 
	DWORD nSamplesPerSec; 
	DWORD nAvgBytesPerSec; 
	WORD  nBlockAlign; 
	WORD  wBitsPerSample; 
	WORD  cbSize; 
}

struct MPEG1VIDEOINFO {
    VIDEOINFOHEADER hdr;
    DWORD           dwStartTimeCode;
    DWORD           cbSequenceHeader;
    ubyte            bSequenceHeader[1];

	alias hdr this;
}

struct MPEG2VIDEOINFO {
    VIDEOINFOHEADER2    hdr;
    DWORD               dwStartTimeCode;   
    DWORD               cbSequenceHeader;     
    DWORD               dwProfile;     
    DWORD               dwLevel;            
    DWORD               dwFlags;            
    DWORD               dwSequenceHeader[1];     

	alias hdr this;
} 
